=== debian/changelog ===
patool (4.0.2-1) unstable; urgency=medium

  * New upstream release.
  * Use watch version 5.
  * Remove Rules-Requires-Root field.
  * Bump Standards-Version to 4.7.2 (no changes).

 -- Abhijith PA <abhijith@debian.org>  Thu, 16 Oct 2025 10:54:48 +0530
