=== debian/tests/control ===
Test-Command: patool formats
Depends: @
Restrictions: allow-stderr
