=== debian/watch ===
Version: 5
Template: Github
Owner: wummel
Project: patool
