## patool 4.0.3

=== debian/changelog ===
patool (4.0.3-1) unstable; urgency=medium

  * New upstream release (Closes: #1118395)

 -- Abhijith PA <abhijith@debian.org>  Wed, 17 Dec 2025 20:33:54 +0530
