## patool 4.0.4

=== Makefile ===
--- 
+++ 
@@ -52,9 +52,6 @@
 
 ############ Installation and provisioning  ############
 
-# these targets work best in a virtual python environment
-# see https://github.com/pyenv/pyenv for more info
-
 .PHONY: init
 init: ## install python virtual env and required development packages
 	uv sync
@@ -78,13 +75,13 @@
 
 .PHONY: dist
 dist: ## build source and wheel distribution file
-	uv build
+	env SOURCE_DATE_EPOCH=$(shell git log -1 --pretty=%ct) uv build
 
 .PHONY: release-pypi
 release-pypi: ## upload a new release to pypi
 	uv publish dist/$(ARCHIVE_SOURCE) dist/$(ARCHIVE_WHEEL)
 
-# export GITHUB_TOKEN for the hub command
+# export GITHUB_TOKEN for the gh command
 # Generate a fine grained access token with:
 # - Restricted to this repository (patool)
 # - Repository permission: Metadata -> Read (displayed as "Read access to metadata" in token view)
@@ -179,15 +176,20 @@
 lint: ## lint python code
 	ruff check $(PY_FILES_DIRS)
 
+.PHONY: audit
+audit: ## run audit checks
+	zizmor --config .zizmor.yml .github/workflows/python-package.yml
+	pip-audit
+
 .PHONY: reformat
 reformat: ## format the python code
 	ruff check --fix $(PY_FILES_DIRS)
 	ruff format $(PY_FILES_DIRS)
 
-.PHONY: checkoutdated checkoutdatedpy checkoutdatedgh
-checkoutdated: checkoutdatedpy checkoutdatedgh
-
-checkoutdatedpy:	## Check for outdated package requirements
+.PHONY: checkoutdated checkoutdated-py checkoutdated-gh
+checkoutdated: checkoutdated-py checkoutdated-gh
+
+checkoutdated-py:	## Check for outdated package requirements
 # Assumes all packages in requirements have pinned versions with "==".
 # Compare the output of "uv pip list" (the current versions) with the result of "uv pip compile" (available versions).
 # Then filter only for upgrades of direct dependencies with grep.
@@ -199,19 +201,26 @@
 	grep -iE "($(shell grep == pyproject.toml  | cut -f1 -d= | tr -d "\"\' "| sed -e 's/\[.*\]//' |sort | paste -sd '|'))"; \
 	test $$? = 1
 
-checkoutdatedgh:	## check for outdated github tools
+checkoutdated-gh:	## check for outdated github projects
 # github-check-outdated is a local tool which compares a given version with the latest available github release version
 # see https://gist.github.com/wummel/ef14989766009effa4e262b01096fc8c for an example implementation
 	@echo "Check for outdated Github tools"
-	github-check-outdated astral-sh uv "$(shell uv self version | cut -f2 -d" ")"
+	github-check-outdated astral-sh uv "$(shell uv --version | cut -f2 -d" ")"
+	github-check-outdated python cpython v$(shell python --version | cut -f2 -d" ") '^v3\.14\.[0-9]+$$'
 
 
 .PHONY: upgradeoutdated
-upgradeoutdated:	upgradeoutdatedgh
-
-.PHONY: upgradeoutdatedgh
-upgradeoutdatedgh:
+upgradeoutdated:	upgradeoutdated-gh upgradeoutdated-py
+
+.PHONY: upgradeoutdated-gh
+upgradeoutdated-gh:
 	sed -i -e 's/uv_version_dev = ".*"/uv_version_dev = "$(shell github-check-outdated astral-sh uv 0 | cut -f4 -d" ")"/' pyproject.toml
+	sed -i -e 's/ version: ".*"/ version: "$(shell github-check-outdated astral-sh uv 0 | cut -f4 -d" ")"/' .github/workflows/python-package.yml
+
+.PHONY: upgradeoutdated-py
+upgradeoutdated-py:	## upgrade dependencies in uv.lock
+	uv lock --upgrade
+
 
 ############ Testing ############
