=== debian/changelog ===
patool (4.0.4-1) unstable; urgency=medium

  * New upstream release.
  * Bump python3-all version to 3.13.
  * Bump Standards-Version to 4.7.3 (no changes).

 -- Abhijith PA <abhijith@debian.org>  Wed, 28 Jan 2026 17:26:28 +0530
