=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Build-Depends: debhelper-compat (= 13),
                dh-python,
                bash-completion,
-               python3-all (>= 3.11),
+               python3-all (>= 3.12),
                python3-setuptools,
                python3-pytest
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/debian/patool
 Vcs-Git: https://salsa.debian.org/debian/patool.git
 Homepage: https://wummel.github.io/patool/
